#include "nvfs.h"

void nvfs_memzero_flushcache(char *ptr, size_t len)
{
	memset(ptr, 0, len);
	arch_wb_cache_pmem(ptr, len);
}

uint64_t nvfs_get_random(uint64_t limit)
{
	if (limit < 0x1000000) {
		return prandom_u32() % (uint32_t)limit;
	} else {
		uint64_t result;
		uint64_t v = prandom_u32() | ((uint64_t)prandom_u32() << 32);
		div64_u64_rem(v, limit, &result);
		return result;
	}
}

unsigned long nvfs_find_bit_in_bmp(uint8_t *bitmap, unsigned long start, unsigned long end)
{
	unsigned long o;
	if (!test_bit_le(start, bitmap))
		return start;

	cond_resched();
	o = find_next_zero_bit_le(bitmap, end, start);
	if (o < end)
		return o;
	cond_resched();
	o = find_next_zero_bit_le(bitmap, start, 0);
	if (o < start)
		return o;
	cond_resched();

	return ~0;
}
